
#include <Rcpp.h>

using namespace Rcpp;

int partition(NumericVector A, int p, int r, int *count)
{
    double tmp, x = A[r];
    int j, i = p-1;
    for (j = p; j < r; j++) {
	if (A[j] <= x) {
	    count[0]++; // increases comparison count
	    i++;
	    tmp = A[i];
	    A[i] = A[j];
	    A[j] = tmp;
	}
    }
    tmp = A[r];
    A[r] = A[i+1];
    A[i+1] = tmp;
    return i+1;
}

void quicksort(NumericVector A, int p, int r, int *count)
{
    if (p < r) {
	int q = partition(A, p, r, count);
	quicksort(A, p, q-1, count);
	quicksort(A, q+1, r, count);
    }
    return;
}


// [[Rcpp::export]]
double order_statistic(Rcpp::NumericVector x, int w)
{
    int i, n = x.length(), count = 0;
    Rcpp::NumericVector A(n);
    for (i = 0; i < n; i++) A[i] = x[i];
    quicksort(A, 0, n-1, &count);
    return A(w-1);
}

// [[Rcpp::export]]
int ncomparisons(Rcpp::NumericVector x, int w)
{
    int i, n = x.length(), count = 0;
    Rcpp::NumericVector A(n);
    for (i = 0; i < n; i++) A[i] = x[i];
    quicksort(A, 0, n-1, &count);
    return count;
}

